
/************** PROGRAMA CANÓ ROBÒTIC TDR **************\
                  MIQUEL OLLER OLIVERAS
                  -----RECEPTOR-----
 */
 


// LLIBRARIES:
#include <Servo.h>      //Afegim una llibreria pel control dels servos
#include "DualVNH5019MotorShield.h"  //Afegim una llibreria creada expressament per controlar els motors mitjançant el driver DualVBH5019

DualVNH5019MotorShield md;   //assignem el driver en nom de md (motordriver)i prenem els valors dels pins PER DEFECTE!: 
/*   INA1 = pin 2, INB1 = pin 4, EN1DIAG1 = pin 6, CS1 = pin A0,
     INA2 = pin 7, INB2 = pin 8, EN2DIAG2 = pin 12, CS2 = pin A1,
     M1PWM = pin 9, M2PWM = pin 10 
*/
//Si un cas hem de canviar els pins, escriure: [on unsigned char = pin ]
/*DualVNH5019MotorShield(unsigned char INA1, unsigned char INB1, unsigned char EN1DIAG1, unsigned char CS1,
unsigned char INA2, unsigned char INB2, unsigned char EN2DIAG2, unsigned char CS2) */  
// M1PWM= pin9 M2PWM= pin10   // aquests no es poden canviar

// VARIABLES:
int serial; //variable anomenada serial per la lectura de la comunicació serial
int i1=90; //variable servo1      */// utilitzem aquestes variables per recordar la posició del servo. Aquests són els valors inicials.
int i2=90; //variable servo2
int i3=90; //variable servo3
int x = 180; //Posició servo 1(SERVO DE DISPARAR ) inicial
int y = 90;//Posició servo 2(SERVO CONTROL GIR BASE) inicial
int z = 90;//Posició servo 3(SERVO CONTROL ANGLE) inicial

Servo servo1; //afegim un servo anomenat servo1 -> servo del gatell
Servo servo2; //afegim un servo anomenat servo2 -> servo control de gir
Servo servo3; //afegim un servo anomenat servo3 -> servo control de l'angle

//PROGRAMARI

//_________________________________ SET UP
void setup()
{
  
  // inici de la comunicació serial:
  Serial.begin(57600);
  //configuració dels pins:

 //inici del Driver:
 md.init();
 //Pins SERVO:
servo1.attach(3); // servo1(servo del gatell) al pin 3
servo2.attach(5); // servo2(servo control de gir) al pin 5
servo3.attach(13); // servo3(servo control de l'angle) al pin 13
}

//_________________________________ LOOP
void loop()
{
 
  if (Serial.available() > 0) {   //comprovem si hi ha comunicació Serial
  serial = Serial.read();  //anomanem seral als valors que rebem per la comunicació Serial
      //servo 1:
    if(serial == 'A') x=0;      // si el valor del serial és = a A [que equival al botó R1 del comandament] el servo es mou a la posició 0º
    if(serial == 'Z') x=180;    // si no és igual a A, posició = 180º             <<< x = posició del servo1  >>> 
    //servo 2:
    if(serial == 'M') y = i2 - 5; // si els valor del serial és = a M [que equival al botó del PAD DRET] el servo gira 5º a la dreta      inicialment està a la posició intermitja = 90º
    if(serial == 'N') y = i2 + 5; // si els valor del serial és = a N [que equival al botó del PAD ESQUERRA] el servo gira 5º a l'esquerra    <<< y = posició del servo2 >>> <<< i2 = posició anterior del servo >>>  
    //servo 3:
    if(serial == 'U') z = i3 - 5; // si els valor del serial és = a U [que equival al botó del PAD AMUNT] el servo de l'angle puja 5º    inicialment està a la posició intermitja = 90º
    if(serial == 'D') z = i3 + 5; // si els valor del serial és = a D [que equival al botó del PAD AVALL] el servo de l'angle baixa  5º a l'esquerra    <<< z = posició del servo3 >>> <<< i3 = posició anterior del servo >>>
    //S2:
      if(y>=180) y=180;  // ens assegurem que tant y com z siguin valors compresos entre [0º, 180º]
      if(y<=0) y=0; 
    //S3:
      if(z>=180) z= 180;
      if(z<=0) z= 0;
      
    //MOVIMENT:--------             M1 = motors del costat esquerra            M2 = motors del costat dret              velocitat de 0 a 400
     //endevant: 
   if(serial == 'a'){       //controlem la velocitat de gir dels motors: a = 100 endevant / b = 200 endevant / c = 300 endevant i F = 400 endevant  
    md.setM1Speed(-100);
    md.setM2Speed(100);
    } 
    if(serial == 'b'){
    md.setM1Speed(-200);
    md.setM2Speed(200);
    }
    if(serial == 'c'){
    md.setM1Speed(-300);
    md.setM2Speed(300);
    }
    if(serial == 'F'){
    md.setM1Speed(-400);
    md.setM2Speed(400);
    }
    //endarrera:
   if(serial == 'd'){       //controlem la velocitat de gir dels motors: d = 100 endarrera / e = 200 endarrera / f = 300 endarrera i B = 400 endarrera
    md.setM1Speed(100);
    md.setM2Speed(-100);
   } 
   if(serial == 'e'){
    md.setM1Speed(200);
    md.setM2Speed(-200);
   }
   if(serial == 'f'){
    md.setM1Speed(300);
    md.setM2Speed(-300);
   }
   if(serial == 'B'){
    md.setM1Speed(400);
    md.setM2Speed(-400);
   }
   //dreta: 
   if(serial == 'g'){          //controlem la velocitat de gir dels motors, per girar a la dreta els motors del costat dret giren endarrera i els de l'esquerra endevant: g = 100 gir dreta / h = 200 gir dreta / i = 300 gir dreta i R = 400 gir dreta
     md.setM1Speed(-100);
     md.setM2Speed(-100);
   }
    if(serial == 'h'){
     md.setM1Speed(-200);
     md.setM2Speed(-200);
   }
    if(serial == 'i'){
     md.setM1Speed(-300);
     md.setM2Speed(-300);
   }
    if(serial == 'R'){
     md.setM1Speed(-400);
     md.setM2Speed(-400);
   }
   //esquerra:
   if(serial == 'j'){           //controlem la velocitat de gir dels motors, per girar a l'esquerra els motors del costat dret giren endevant i els de l'esquerra endarrera: j = 100 gir esquerra / k = 200 gir esquerra / l = 300 gir dreta i L = 400 girdreta  
     md.setM1Speed(100);
     md.setM2Speed(100);
   }
   if(serial == 'k'){
     md.setM1Speed(200);
     md.setM2Speed(200);
   }
   if(serial == 'l'){
     md.setM1Speed(300);
     md.setM2Speed(300);
   }
   if(serial == 'L'){
     md.setM1Speed(400);
     md.setM2Speed(400);
   }
   //STOP:
   if (serial == 'S'){      // si el serial és igual a S (Stop) (joystics en la posició de repòs) els motors paren -> motor brake = 400 = màxim
      md.setM1Brake(400);
      md.setM2Brake(400);
   }
     
      //Servo 1:                // escribim la posició en graus en els servos
      servo1.write(x);
      //Servo 2:
      servo2.write(y);
      //Servo 3:
       servo3.write(z);
       
       i1 = x;                  //per recordar la posició igualem la posició actual a la i del motor que es farà servir per ampliar o reduir el valor de l'angle
       i2 = y;
       i3 = z;
  }
      
      delay(50);                // fem una petita pausa per que els motors es puguin posar a la posició
}
                  
 //_________________________________ DRIVE
/*
  void forward()
{
    digitalWrite(mot1, HIGH);
    digitalWrite(mot2, LOW);
    digitalWrite(mot3, HIGH);
    digitalWrite(mot4, LOW);

}

void backward()
{
    digitalWrite(mot1, LOW);
    digitalWrite(mot2, HIGH);
    digitalWrite(mot3, LOW);
    digitalWrite(mot4, HIGH);

}

void right()
{
    digitalWrite(mot1, HIGH);
    digitalWrite(mot2, LOW);
    digitalWrite(mot3, LOW);
    digitalWrite(mot4, HIGH);
 
}

void left()
{
    digitalWrite(mot1, LOW);
    digitalWrite(mot2, HIGH);
    digitalWrite(mot3, HIGH);
    digitalWrite(mot4, LOW);
}

void STOP()  
{
    digitalWrite(mot1, LOW);
    digitalWrite(mot2, LOW);
    digitalWrite(mot3, LOW);
    digitalWrite(mot4, LOW);
}

*/

