


/************ PROGRAMA COMANDAMENT CANÓ ROBÒTIC TDR ************\
                   MIQUEL OLLER OLIVERAS 
                   -----EMISOR-----
  */
  
 //CABLES MANDO:
    // attention (groc) [10]
    // command (taronja) [9]
    // clock (blau) [13]
    // data (marro) [12]
    // 5V (vermell) 
    // GND (negre) 
 
 //LLIBRARIES
 #include <PS2X_lib.h>
 
 PS2X ps2x; // crea el mando de la play 2
 
  // PINS:
  int LedVerd = 7 ;
  int LedVermell = 4;
  
  //VARIABLES:
  int error = 0; 
byte type = 0;
byte vibrate = 0;
 int Led = 0;
 
 //_________________________________ SET UP
 void setup()
 {
  // inici de la comunicació serial: (velocitat de communicació 57600b)
  Serial.begin(57600);
  
  // CONFIGURACIÓ DE PINS:
  pinMode(LedVerd, OUTPUT);
  pinMode(LedVermell, OUTPUT);
 
  error = ps2x.config_gamepad(13,9,10,12, true, true);   //inici dels pins del comandament:  GamePad(clock, command, attention, data, Pressures?, Rumble?) comprovar l' error 
 }
 
  //_________________________________ LOOP
 void loop()
 {
   ps2x.read_gamepad(false, vibrate); 
   //PAD
      if(ps2x.ButtonPressed(PSB_PAD_UP)) {    //si s'apreta el botó del PAD amunt, imprimim al serial la lletra U              
       Serial.write('U');
      }
      if(ps2x.ButtonPressed(PSB_PAD_RIGHT)){               
       
       Serial.write('M'); 
      }
      if(ps2x.ButtonPressed(PSB_PAD_LEFT)){                
       
        Serial.write('N');
      }
      if(ps2x.ButtonPressed(PSB_PAD_DOWN)){                
       
       Serial.write('D');
      }    
      
    //JOYSTICKS:
      //endevant:
     if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('F');
     }
     if(ps2x.Analog(PSS_LY)>0 && ps2x.Analog(PSS_LY)<=40 && ps2x.Analog(PSS_RY)>0 && ps2x.Analog(PSS_RY)<=40)
     {
      Serial.write('c');
     }
     if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)>0 && ps2x.Analog(PSS_RY)<=40)
     {
      Serial.write('c');
     }
     if(ps2x.Analog(PSS_LY)>0 && ps2x.Analog(PSS_LY)<=40 && ps2x.Analog(PSS_RY)==0 )
     {
      Serial.write('c');
     }
     if(ps2x.Analog(PSS_LY)>40 && ps2x.Analog(PSS_LY)<=80 && ps2x.Analog(PSS_RY)>40 && ps2x.Analog(PSS_RY)<=80)
     {
      Serial.write('b');
     }
      if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)>40 && ps2x.Analog(PSS_RY)<=80)
     {
      Serial.write('b');
     }
      if(ps2x.Analog(PSS_LY)>40 && ps2x.Analog(PSS_LY)<=80 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('b');
     }
     if(ps2x.Analog(PSS_LY)>80 && ps2x.Analog(PSS_LY)<=127 && ps2x.Analog(PSS_RY)>80 && ps2x.Analog(PSS_RY)<=127)
     {
      Serial.write('a');
     }
     if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)>80 && ps2x.Analog(PSS_RY)<=127)
     {
      Serial.write('a');
     }
     if(ps2x.Analog(PSS_LY)>80 && ps2x.Analog(PSS_LY)<=127 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('a');
     }
     
      //enderrera:
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)==255)
     {
      Serial.write('B');
     }
     if(ps2x.Analog(PSS_LY)<255 && ps2x.Analog(PSS_LY)>=215 && ps2x.Analog(PSS_RY)<255 && ps2x.Analog(PSS_RY)>=215)
     {
      Serial.write('f');
     }
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)<255 && ps2x.Analog(PSS_RY)>=215)
     {
      Serial.write('f');
     }
     if(ps2x.Analog(PSS_LY)<255 && ps2x.Analog(PSS_LY)>=215 && ps2x.Analog(PSS_RY)==255)
     {
      Serial.write('f');
     }
     if(ps2x.Analog(PSS_LY)<215 && ps2x.Analog(PSS_LY)>=175 && ps2x.Analog(PSS_RY)<215 && ps2x.Analog(PSS_RY)>=175)
     {
      Serial.write('e');
     }
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)<215 && ps2x.Analog(PSS_RY)>=175)
     {
      Serial.write('e');
     }
     if(ps2x.Analog(PSS_LY)<215 && ps2x.Analog(PSS_LY)>=175 && ps2x.Analog(PSS_RY)==225)
     {
      Serial.write('e');
     }
     if(ps2x.Analog(PSS_LY)<175 && ps2x.Analog(PSS_LY)>=129 && ps2x.Analog(PSS_RY)<175 && ps2x.Analog(PSS_RY)>=129)
     {
      Serial.write('d');
     }
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)<175 && ps2x.Analog(PSS_RY)>=129)
     {
      Serial.write('d');
     }
     if(ps2x.Analog(PSS_LY)<175 && ps2x.Analog(PSS_LY)>=129 && ps2x.Analog(PSS_RY)==255)
     {
      Serial.write('d');
     }
     
      //dreta:
     if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)==255)
     {
      Serial.write('R');
     }
     if(ps2x.Analog(PSS_LY)>0 && ps2x.Analog(PSS_LY)<=40 && ps2x.Analog(PSS_RY)<255 && ps2x.Analog(PSS_RY)>=215)
     {
      Serial.write('i');
     }
     if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)<255 && ps2x.Analog(PSS_RY)>=215)
     {
      Serial.write('i');
     }
     if(ps2x.Analog(PSS_LY)>0 && ps2x.Analog(PSS_LY)<=40 && ps2x.Analog(PSS_RY)==255 )
     {
      Serial.write('i');
     }
     if(ps2x.Analog(PSS_LY)>40 && ps2x.Analog(PSS_LY)<=80 && ps2x.Analog(PSS_RY)<215 && ps2x.Analog(PSS_RY)>=175)
     {
      Serial.write('h');
     }
     if(ps2x.Analog(PSS_LY)==0  && ps2x.Analog(PSS_RY)<215 && ps2x.Analog(PSS_RY)>=175)
     {
      Serial.write('h');
     }
     if(ps2x.Analog(PSS_LY)>40 && ps2x.Analog(PSS_LY)<=80 && ps2x.Analog(PSS_RY)==255)
     {
      Serial.write('h');
     }
     if(ps2x.Analog(PSS_LY)>80 && ps2x.Analog(PSS_LY)<=127 && ps2x.Analog(PSS_RY)<175 && ps2x.Analog(PSS_RY)>=129)
     {
      Serial.write('g');
     }
     if(ps2x.Analog(PSS_LY)==0 && ps2x.Analog(PSS_RY)<175 && ps2x.Analog(PSS_RY)>=129)
     {
      Serial.write('g');
     }
     if(ps2x.Analog(PSS_LY)>80 && ps2x.Analog(PSS_LY)<=127 && ps2x.Analog(PSS_RY)==255)
     {
      Serial.write('g');
     }
     
      //esquerra:
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('L');
     }
     if(ps2x.Analog(PSS_LY)<255 && ps2x.Analog(PSS_LY)>=215 && ps2x.Analog(PSS_RY)>0 && ps2x.Analog(PSS_RY)<=40)
     {
      Serial.write('l');
     } 
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)>0 && ps2x.Analog(PSS_RY)<=40)
     {
      Serial.write('l');
     } 
     if(ps2x.Analog(PSS_LY)<255 && ps2x.Analog(PSS_LY)>=215 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('l');
     } 
     if(ps2x.Analog(PSS_LY)<215 && ps2x.Analog(PSS_LY)>=175 && ps2x.Analog(PSS_RY)>40 && ps2x.Analog(PSS_RY)<=80)
     {
      Serial.write('k');
     }
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)>40 && ps2x.Analog(PSS_RY)<=80)
     {
      Serial.write('k');
     }
     if(ps2x.Analog(PSS_LY)<215 && ps2x.Analog(PSS_LY)>=175 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('k');
     }
     if(ps2x.Analog(PSS_LY)<175 && ps2x.Analog(PSS_LY)>=129 && ps2x.Analog(PSS_RY)>80 && ps2x.Analog(PSS_RY)<=127)
     {
      Serial.write('j');
     }
     if(ps2x.Analog(PSS_LY)==255 && ps2x.Analog(PSS_RY)>80 && ps2x.Analog(PSS_RY)<=127)
     {
      Serial.write('j');
     }
     if(ps2x.Analog(PSS_LY)<175 && ps2x.Analog(PSS_LY)>=129 && ps2x.Analog(PSS_RY)==0)
     {
      Serial.write('j');
     }
     
      //STOP:
      if(ps2x.Analog(PSS_LY)==128 && ps2x.Analog(PSS_RY)==128)
     {
      Serial.write('S');
     }
     
     //R1
     if(ps2x.ButtonPressed(PSB_R1))
     {
      Serial.write('A');
     }
     if(ps2x.ButtonReleased(PSB_R1))
     {
      Serial.write('Z');
     }
     //R2 i L2
    
     if(ps2x.Button(PSB_L2))
     {
      Serial.write('F');
     } 
     if(ps2x.Button(PSB_R2))
     {
      Serial.write('B');
     }    
    
    
   //Control de l'alimentació dels servos:
   if(ps2x.ButtonPressed(PSB_PINK)) //  activem/desactivem els servos mitjançant un transistor
   {
     Serial.write('W');
     if(Led==0) Led=1;   //  <<<<<<<<-------- POSSIBLE PROBLEMA!!!
     else if(Led==1) Led=0;
   }
    
    
   //Encesa de LEDs 
   if(ps2x.ButtonPressed(PSB_BLUE))
   {
     Serial.write('X');
   }
   
  
   if(Led==0)
   {
     LedVerd = LOW;
     LedVermell = HIGH;
   }
   if(Led==1)
   {
     LedVerd = HIGH;
     LedVermell = LOW;
   }
    
    */  
      
   
    delay(10);
 }

